<template>
  <div>
    <div class="page-title">
      <h3>{{ 'Planning' | localization }}</h3>
      <h4>{{ userInfo.bill | currency('UAH') }}</h4>
    </div>

    <Loader v-if="loading" />

    <p v-else-if="!categories.length" class="center">
      {{ 'No categories yet' | localization }}.
      <router-link to="/categories">
        {{ 'Add new category' | localization }}
      </router-link>
    </p>

    <section v-else>
      <div v-for="c in categories" :key="c.id">
        <p>
          <strong>{{ c.name }}:</strong>
          {{ c.spent | currency('UAH') }} из {{ c.limit | currency('UAH') }}
        </p>
        <div class="progress" v-tooltip="c.restTooltip">
          <div
              class="determinate"
              :class="c.color"
              :style="{width: c.percent + '%'}"
          ></div>
        </div>
      </div>
    </section>
  </div>
</template>

<script>
import currency from "@/filters/currency";
import localization from "@/filters/localization";

export default {

  name: "Planning",
  data: () => ({
    loading: true,
    categories: []
  }),
  computed: {
    userInfo() {
      return this.$store.getters.getUserInfo;
    }
  },
  async mounted() {
    const categories = await this.$store.dispatch('getCategories');
    const records = await this.$store.dispatch('getRecords');
    this.loading = false;


    this.categories = categories.map(c => {

      const spent = records.filter(r => r.categoryId === c.id)
                           .filter(r => r.type === 'outcome')
                           .reduce((total, record) => {
                             return total += record.amount;
                           }, 0);

      let percent = 100 * spent / c.limit;
      percent = percent > 100 ? 100 : percent;

      let color = 'green';

      if (100 === percent) {
        color = 'red';
      } else if (percent > 60) {
        color = 'yellow';
      }

      let restTooltip = '';
      if (spent > c.limit) {
        restTooltip += localization('Limit exceeds to ');
      } else {
        restTooltip += localization('Left ');
      }
      restTooltip += currency(Math.abs(c.limit - spent));


      return {
        ...c,
        spent,
        percent,
        color,
        restTooltip
      };

    });

  }
}
</script>

<style scoped>

</style>